import pygame

class BoardField():
    __name:str
    __type:str
    __pos:pygame.Vector2
    __size:tuple
    __color:tuple = (255,255,255)
    _rect:pygame.Rect

    def __init__(self, name:str, type:str, pos:pygame.Vector2, size:tuple, color:tuple):
        self.__name = name
        self.__type = type
        self.__pos = pos
        self.__size = size
        self.__color = color
        self.__rect = pygame.Rect(pos.x, pos.y, size[0], size[1])

    def getName(self) -> str:
        return self.__name

    def getType(self) -> str:
        return self.__type

    def getPos(self) -> pygame.Vector2:
        return self.__pos

    def getSize(self) -> tuple:
        return self.__size

    def getColor(self) -> tuple:
        return self.__color

    def getRect(self) -> pygame.Rect:
        return self.__rect

    def setName(self, name:str) -> str:
        self.__name = name
        return self.__name

    def setType(self,type:str) -> str:
        self.__type = type
        return self.__type

    def setPos(self, pos:pygame.Vector2) -> pygame.Vector2:
        self.pos = pos
        return self.__pos

    def setSize(self, size:tuple) -> tuple:
        self.__size = size
        return self.__size

    def setColor(self, color:tuple) -> tuple:
        self.__color = color
        return self.__color