import json
from typing import Any

import pygame

class MonsterCard(pygame.sprite.Sprite):
    __attacks = []
    __name:str
    __description:str
    image:pygame.image
    rect:pygame.rect

    def __init__(self, pos:tuple, assetDir:str):
        if assetDir == "":
            return ValueError.add_note("Card: imagePath cannot be empty")
        
        pygame.sprite.Sprite.__init__(self)

        data = json.load(open(assetDir + "/testmonstercard.json"))

        self.__name = data["name"]
        self.image = pygame.image.load(assetDir + "/card.png").convert_alpha()
        self.rect = self.image.get_rect()
        self.rect.center = pos
        self.__description = data["description"]

        for attack in data["attacks"]:
            self.__attacks.append(attack)

    def update(self):
        pass

    def attacks(self):
        return self.__attacks
    
    def getName(self) -> str:
        return self.__name

    def getCardSprite(self) -> pygame.image:
        return self.__cardSprite
    
    def getDescription(self):
        return self.__description
